﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace Jewels_DMilian
{
    public partial class Game : Form
    {
        public Point TimeLimit = new Point(0, 0), Time, MPos = new Point(0, 0), Sel = new Point(-1, -1);
        public int[,] Map = new int[8, 8];
        public List<List<int>> MapNext = new List<List<int>>();
        public int PtsY = 0, Points = 0;
        public long ShowTime = 20000000, AtShowing = 0, WrongSelTime = 10000000, WrongSelShowing = 0, TimeChanged = 0;
        public bool MouseClck = false, CanPlay = true, GameEnd = false;
        public int GameEndReason = -1;
        public List<Point[]> SelRange = new List<Point[]>();
        public List<Point> WrongSels = new List<Point>();
        public bool AutoGen = false;
        public Color[] Colours = new Color[] { Color.Pink, Color.LightGreen, Color.LightBlue, Color.White, Color.Yellow, Color.Purple, Color.Black };

        public Game()
        {
            InitializeComponent();
        }

        private void Game_Load(object sender, EventArgs e)
        {
            this.DoubleBuffered = true;
            this.ClientSize = new Size(800, 600);
            Time = new Point(TimeLimit.X, TimeLimit.Y);
            if (AutoGen)
            {
                GenerateMap();
                while (!CheckForOptions()) { GenerateMap(); }
            }
            else
            {
                /*string[] fl = Directory.GetFiles(".");
                foreach (string f in fl) { MessageBox.Show(f); }*/
                if (!File.Exists("mapa.txt")) { MessageBox.Show("Soubor \"mapa.txt\" neexistuje."); Application.Exit();return; }
                StreamReader read = new StreamReader("mapa.txt");
                string line;
                int cline = 0;
                while ((line = read.ReadLine()) != null)
                {
                    if (cline < 8)
                    {
                        for (int i = 0;i<8;i++)
                        {
                            int num = int.Parse(line.Substring(i, 1));
                            Map[i, cline] = num;
                        }
                    }
                    else
                    {
                        MapNext.Add(new List<int>());
                        for (int i =0;i<line.Length;i++)
                        {
                            int num = int.Parse(line.Substring(i, 1));
                            MapNext[cline - 8].Add(num);
                        }
                    }
                    cline++;
                }
                read.Close();
                if (!CheckForOptions()) { GameEnd= true;GameEndReason = 1; }
            }
            this.Invalidate();
        }

        public void GenerateMap()
        {
            Random rand = new Random();
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    Map[j, i] = -1;
                }
            }


            for (int i = 0; i < 8; i++)
            {

                for (int j = 0; j < 8; j++)
                {
                    if (Map[j, i] != -1) { continue; }
                    int cns = rand.Next(1, 2), sd = rand.Next(1, 2), add = rand.Next(5);
                    if (j == 7 && cns == 2 && sd == 1) { cns = 1; }
                    else if (i == 7 && cns == 2 && sd == 2) { cns = 1; }
                    if (i > 1)
                    {
                        if (Map[j, i - 1] == add && Map[j, i - 2] == add)
                        {
                            int dadd = add;
                            while (add == dadd)
                            {
                                add = rand.Next(5);
                            }
                            cns = 1;
                        }
                        else if (Map[j, i - 1] == add)
                        {
                            int gadd = rand.Next(1);
                            if (gadd == 0)
                            {
                                int dadd = add;
                                while (add == dadd)
                                {
                                    add = rand.Next(5);
                                }
                            }
                            cns = 1;
                        }
                    }
                    if (j > 1)
                    {
                        if (Map[j - 1, i] == add && Map[j - 2, i] == add)
                        {
                            int dadd = add;
                            while (add == dadd)
                            {
                                add = rand.Next(5);
                            }
                            cns = 1;
                        }
                    }
                    for (int k = 0; k < cns; k++)
                    {
                        if (sd == 1) { Map[j + k, i] = add; }
                        else { Map[j, i + k] = add; }
                    }

                    //Map[i, j] = rand.Next(5);
                }
            }
        }
        public bool CheckForOptions()
        {
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    int c = Map[j, i], x = j, y = i;
                    if (c == -1) { continue; }
                    //MoveLeft
                    if (j > 0)
                    {
                        x = j - 1;
                        y = i;
                    }
                    //MoveRight
                    if (j < 7)
                    {
                        x = j + 1;
                        y = i;
                    }
                    //MoveUp
                    if (i > 0)
                    {
                        x = j;
                        y = i - 1;
                    }
                    //MoveDown
                    if (i < 7)
                    {
                        x = j;
                        y = i + 1;
                    }

                    if (x == j && y == i) { continue; }
                    if (x > 1)
                    {
                        if (Map[x - 1, y] == c && Map[x - 2, y] == c) { return true; }
                    }
                    if (x < 6)
                    {
                        if (Map[x + 1, y] == c && Map[x + 2, y] == c) { return true; }
                    }
                    if (y > 1)
                    {
                        if (Map[x, y - 1] == c && Map[x, y - 2] == c) { return true; }
                    }
                    if (y < 6)
                    {
                        if (Map[x, y + 1] == c && Map[x, y + 2] == c) { return true; }
                    }
                }
            }
            return false;
        }
        public bool CheckForOptionsAndDelete()
        {
            int pts = 0;
            //List<Point> dels = new List<Point>();
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    int c = Map[j, i], x = j, y = i;
                    if (c == -1) { continue; }
                    if (x > 1)
                    {
                        if (Map[x - 1, y] == c && Map[x - 2, y] == c)
                        {
                            pts += 3;
                            /*dels.Add(new Point(x, y));
                            dels.Add(new Point(x - 1, y));
                            dels.Add(new Point(x - 2, y));*/
                            SelRange.Add(new Point[] { new Point(x - 2, y), new Point(x, y) });
                        }
                    }
                    /*if (x < 6)
                    {
                        if (Map[x + 1, y] == c && Map[x + 2, y] == c)
                        {
                            pts += 3;
                            SelRange.Add(new Point[] { new Point(x, y), new Point(x + 2, y) });
                        }
                    }*/
                    if (y > 1)
                    {
                        if (Map[x, y - 1] == c && Map[x, y - 2] == c)
                        {
                            pts += 3;
                            /*dels.Add(new Point(x, y));
                            dels.Add(new Point(x, y - 1));
                            dels.Add(new Point(x, y - 2));*/
                            SelRange.Add(new Point[] { new Point(x, y - 2), new Point(x, y) });
                        }
                    }
                    /*if (y < 6)
                    {
                        if (Map[x, y + 1] == c && Map[x, y + 2] == c)
                        {
                            pts += 3;
                            SelRange.Add(new Point[] { new Point(x, y), new Point(x, y + 2) });
                        }
                    }*/
                }
            }
            if (pts != 0) { AtShowing = DateTime.Now.Ticks; }
            Points += pts;
            if (pts > 0) { return true; }
            return false;
        }
        public void DeleteRanges()
        {
            foreach (Point[] pt in SelRange)
            {
                //Map[pt.X, pt.Y] = -1;
                if (pt[1].X != pt[0].X)
                {
                    for (int i = pt[0].X; i < pt[1].X; i++)
                    {
                        Map[i, pt[0].Y] = -1;
                    }
                }
                else
                {
                    for (int i = pt[0].Y; i < pt[1].Y; i++)
                    {
                        Map[pt[0].X, i] = -1;
                    }
                }
            }
            SelRange.Clear();
            Random rand = new Random();
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    if (Map[j, i] != -1) { continue; }
                    for (int k = i; k > 0; k--)
                    {
                        Map[j, k] = Map[j, k - 1];
                    }
                    if (AutoGen) { Map[j, 0] = rand.Next(5); }
                    else
                    {
                        if (MapNext[j].Count != 0)
                        {
                            Map[j, 0] = MapNext[j][0];
                            MapNext[j].RemoveAt(0);
                        }
                    }
                }
            }
            CheckForOptionsAndDelete();
            if (!CheckForOptions())
            {
                GameEnd = true;
                GameEndReason = 1;
            }
        }

        private void Game_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left) { MouseClck = true; }
        }

        private void Game_MouseMove(object sender, MouseEventArgs e)
        {
            MPos = new Point(e.X, e.Y);
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            g.FillRectangle(Brushes.Black, new Rectangle(4, 4, 128, ClientSize.Height));
            g.FillRectangle(Brushes.White, new Rectangle(0, 0, 128, ClientSize.Height));
            g.DrawLine(Pens.Black, new Point(128, 0), new Point(128, ClientSize.Height));

            SizeF clc = g.MeasureString("Zbývající čas", this.Font);
            g.DrawString("Zbývající čas", this.Font, Brushes.Black, new PointF(64 - clc.Width / 2f, 8));
            if (TimeLimit != new Point(0, 0))
            {
                string mins, secs;
                mins = Time.X.ToString();
                secs = Time.Y.ToString();
                if (mins.Length == 1) { mins = "0" + mins; }
                if (secs.Length == 1) { secs = "0" + secs; }
                clc = g.MeasureString(mins + " : " + secs, new Font("Calibri", 16f));
                g.DrawString(mins + " : " + secs, new Font("Calibri", 16f), Brushes.Black, new PointF(64 - clc.Width / 2f, 20f));
                if (DateTime.Now.Ticks >= TimeChanged + 10000000 && !GameEnd)
                {
                    TimeChanged = DateTime.Now.Ticks;
                    Time.Y--;
                    if (Time.Y < 0) { Time.X--; Time.Y = 59; }
                    if (Time.X < 0)
                    {
                        GameEnd = true;
                        GameEndReason = 0; // Timeout
                        Time.X = 0;
                        Time.Y = 0;
                    }
                }
            }
            else
            {
                clc = g.MeasureString("Není určen", new Font("Calibri", 16f));
                g.DrawString("Není určen", new Font("Calibri", 16f), Brushes.Black, new PointF(64 - clc.Width / 2f, 20f));
            }
            clc = g.MeasureString("Počet bodu", this.Font);
            g.DrawString("Počet bodu", this.Font, Brushes.Black, new PointF(64 - clc.Width / 2f, 64f));
            clc = g.MeasureString(Points.ToString(), new Font("Calibri", 16f));
            g.DrawString(Points.ToString(), new Font("Calibri", 16f), Brushes.Black, new PointF(64 - clc.Width / 2f, 76f));

            int mx, my, myy;
            mx = 128 + (ClientSize.Width - 128) / 2 - 568 / 2;
            my = 16;
            myy = my - ((my + 568) - PtsY);
            g.FillRectangle(new SolidBrush(Color.FromArgb(96, 0, 0, 0)), new Rectangle(mx, my, 568, 568));
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    if (Map[j, i] == -1) { continue; }
                    g.FillEllipse(new SolidBrush(Colours[Map[j, i]]), new Rectangle(mx + 8 + (j * 70), myy + 8 + (i * 70), 62, 62));
                    if (Sel == new Point(j, i))
                    {
                        g.DrawRectangle(new Pen(Color.Red, 3), new Rectangle(mx + 8 + (j * 70), myy + 8 + (i * 70), 62, 62));
                    }
                    if (MPos.X >= mx + 8 + (j * 70) && MPos.X <= mx + 8 + (j * 70) + 62 && MPos.Y >= myy + 8 + (i * 70) && MPos.Y <= myy + 8 + (i * 70) + 62 && !GameEnd)
                    {
                        if (Sel != new Point(j, i)) g.DrawRectangle(new Pen(Color.DarkOrange, 3), new Rectangle(mx + 8 + (j * 70), myy + 8 + (i * 70), 62, 62));
                        if (MouseClck && CanPlay)
                        {
                            if (Sel != new Point(-1, -1))
                            {
                                if ((j == Sel.X - 1 && i == Sel.Y) || (j == Sel.X + 1 && i == Sel.Y) || (i == Sel.Y - 1 && j == Sel.X) || (i == Sel.Y + 1 && j == Sel.X))
                                {
                                    int tmp = Map[j, i];
                                    Map[j, i] = Map[Sel.X, Sel.Y];
                                    Map[Sel.X, Sel.Y] = tmp;
                                    bool suc = CheckForOptionsAndDelete();
                                    if (!suc)
                                    {
                                        WrongSels.Add(new Point(j, i));
                                        WrongSels.Add(new Point(Sel.X, Sel.Y));
                                        tmp = Map[j, i];
                                        Map[j, i] = Map[Sel.X, Sel.Y];
                                        Map[Sel.X, Sel.Y] = tmp;
                                        WrongSelShowing = DateTime.Now.Ticks;
                                    }
                                    Sel = new Point(-1, -1);
                                }
                                else { Sel = new Point(j, i); }
                            }
                            else
                            {
                                if (Sel == new Point(j, i)) { Sel = new Point(-1, -1); }
                                else { Sel = new Point(j, i); }
                            }
                        }
                    }
                }
            }

            if (SelRange.Count != 0)
            {
                if (DateTime.Now.Ticks >= AtShowing && DateTime.Now.Ticks <= AtShowing + ShowTime)
                {
                    CanPlay = false;
                    foreach (Point[] pt in SelRange)
                    {
                        g.DrawRectangle(new Pen(new SolidBrush(Color.Red), 3f), new Rectangle(mx + 8 + (pt[0].X * 70), my + 8 + (pt[0].Y * 70), (mx + 8 + (pt[1].X * 70) + 62) - (mx + 8 + (pt[0].X * 70)), (my + 8 + (pt[1].Y * 70) + 62) - (my + 8 + (pt[0].Y * 70))));
                    }
                }
                else
                {
                    CanPlay = true;
                    DeleteRanges();
                }
            }
            if (WrongSels.Count != 0)
            {
                if (DateTime.Now.Ticks >= WrongSelShowing && DateTime.Now.Ticks <= WrongSelShowing + WrongSelTime)
                {
                    foreach (Point pt in WrongSels)
                    {
                        g.FillRectangle(new SolidBrush(Color.FromArgb(64, 255, 0, 0)), new Rectangle(mx + 8 + (pt.X * 70), my + 8 + (pt.Y * 70), 62, 62));
                    }
                }
                else
                {
                    WrongSels.Clear();
                }
            }

            if (PtsY < my + 568) { PtsY += 5; }
            else { PtsY = my + 568; }
            if (MouseClck) { MouseClck = false; }
            if (GameEnd)
            {
                CanPlay = false;
                Sel = new Point(-1, -1);
                int rx = ClientSize.Width / 2 - 152, ry = ClientSize.Height / 2 - 152;
                g.FillRectangle(new SolidBrush(Color.FromArgb(222, 255, 255, 255)), new Rectangle(ClientSize.Width / 2 - 160, ClientSize.Height / 2 - 160, 320, 320));
                clc = g.MeasureString("Konec Hry", new Font("Calibri", 24f));
                g.DrawString("Konec Hry", new Font("Calibri", 24f), Brushes.Black, new PointF(ClientSize.Width/2-clc.Width/2f, ry));
                string txt = "";
                if (GameEndReason == 0) { txt = "Váš časový limit vypršel."; }
                else if (GameEndReason == 1) { txt = "Neexistují další možné kroky na hracím poli."; }
                g.DrawString(txt, this.Font, Brushes.Black, new RectangleF(rx, ry + 48f, 304f, 128f));
            }
            this.Invalidate();
        }

        private void Game_FormClosing(object sender, FormClosingEventArgs e)
        {
            Application.Exit();
        }
    }
}
